<?php

namespace App\Models;

use App\Entities\MyLogEntity;

class MyLogModel extends CommonModel
{
    const TABLE = "logger";
    const PK = "uid";
    const TITLE = "title";
    protected $table            = self::TABLE;
    protected $primaryKey       = self::PK;
    protected $returnType       = MyLogEntity::class;
    protected $allowedFields = [
        "user_uid",
        "class_name",
        "method_name",
        "title",
        "content",
        "status",
        "updated_at"
    ];
    public function __construct()
    {
        parent::__construct();
    }
    public function getFormFieldRule(string $action, string $field): string
    {
        if (is_array($field)) {
            throw new \Exception(__FUNCTION__ . "=> field가 array 입니다.\n" . var_export($field, true));
        }
        switch ($field) {
            case "user_uid":
                $rule = "if_exist|numeric";
                break;
            default:
                $rule = parent::getFormFieldRule($action, $field);
                break;
        }
        return $rule;
    }
    //List 검색용    
    public function setList_WordFilter(string $word): void
    {
        $this->orLike(self::TABLE . "." . self::TITLE, $word, 'both');
        $this->orLike(self::TABLE . '.content', $word, 'both');
    }
}
